package com.perforce.hws.deployment;

import java.io.IOException;
import java.util.Arrays;

import com.perforce.hws.deployment.deployers.Deployer;

/**
 * Completely wipes the system configuration created by the ConfigureNewSystem class.
 */
public class UninstallSystem {

    /**
     * The main method.
     *
     * @param args the arguments
     */
    public static void main(final String[] args) {
        try {
            boolean inInstaller = false;
            if (Arrays.stream(args).anyMatch(s -> s.equals("--installer"))) {
                inInstaller = true;
            }

            new UninstallSystem().run(inInstaller);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    /**
     * Run.
     *
     * @param inInstaller If true, this is being executed by a package or installer
     * @throws InterruptedException the interrupted exception
     * @throws IOException Signals that an I/O exception has occurred.
     */
    public void run(final boolean inInstaller)
    		throws InterruptedException, IOException {
        Deployer deployer = new DeployerFactory().getDeployer();
        deployer.uninstall(inInstaller);
        deployer.postUninstall();
    }
}
